/* main.c - filter entry point
 * Rob Earhart
 * $Id$
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "filter.h"
#include "msg.h"

static const char rcsid[] = "$Id$";

extern FILE *yyin, *yyout;
extern Cmd *result;
extern int yyparse();
extern int optind;

int main(int argc, char *argv[]) {
  int c, err = 0;
  int print_parse = 0;
  char *prog;

  if (prog = strrchr(argv[0], '/'))
    prog++;
  else
    prog = argv[0];

  while ((c = getopt(argc, argv, "hp")) != -1)
    switch (c) {
    case 'p':
      print_parse = 1;
      break;
    default:
      err++;
      break;
    }
  if (err || optind != argc - 1) {
    fprintf(stderr, "%s: usage: %s [-p] script\n", prog, prog);
    return 1;
  }
  if (! (yyin = fopen(argv[optind], "r"))) {
    perror(argv[optind]);
    return 1;
  }
  yyout=stderr;

  if (yyparse()) {
    puts("normal");
    return 1;
  } else if (print_parse)
    base_Print(result, stdout);
  else if (msg_Slurp(stdin)) {
    fputs("unparseable email message", stderr);
    puts("normal");
    return 1;
  } else
    cmd_Eval(result);
  return 0;
}
